Index: MANIFEST.in
===================================================================
--- MANIFEST.in	(revision 916)
+++ MANIFEST.in	(revision 939)
@@ -1,5 +1,4 @@
 include mlx.nsi
-include makeinst.bat
-include winemakeinst.bat
+include makeinst.sh
 include license.txt
 include runmlx.py
Index: dcdatagen.py
===================================================================
--- dcdatagen.py	(revision 599)
+++ dcdatagen.py	(revision 932)
@@ -1,3 +1,3 @@
-#!/usr/bin/env python
+#!/usr/bin/env python3
 # -*- coding: utf-8 -*-
 
@@ -764,12 +764,12 @@
     numLines = len(lines)
     if numLines==0:
-        print >> file, "msgstr \"\""
+        print("msgstr \"\"", file=file)
     elif numLines==1:
-        print >> file, "msgstr \"%s\"" % (lines[0])
+        print("msgstr \"%s\"" % (lines[0]), file=file)
     else:
-        print >> file, "msgstr \"\""
+        print("msgstr \"\"", file=file)
         for i in range(0, numLines):
-            print >> file, "\"%s%s\"" % (lines[i], "" if i==(numLines-1) else "\\n")
-    print >> file
+            print("\"%s%s\"" % (lines[i], "" if i==(numLines-1) else "\\n"), file=file)
+    print(file=file)
 
 #-------------------------------------------------------------------------------
@@ -789,8 +789,8 @@
             poFile = open(poPath, "wt")
             poFiles.append(poFile)
-            print >> poFile, "msgid \"\""
-            print >> poFile, "msgstr \"\""
-            print >> poFile, "\"Content-Type: text/plain; charset=utf-8\\n\""
-            print >> poFile, "\"Content-Transfer-Encoding: 8bit\\n\""
+            print("msgid \"\"", file=poFile)
+            print("msgstr \"\"", file=poFile)
+            print("\"Content-Type: text/plain; charset=utf-8\\n\"", file=poFile)
+            print("\"Content-Transfer-Encoding: 8bit\\n\"", file=poFile)
 
         (baseData, headings, headingFlags, rows) = table
@@ -801,5 +801,5 @@
             for j in range(0, numLanguages):
                 poFile = poFiles[j]
-                print >> poFile, "msgid \"%sheading%d\"" % (poPrefix, i)
+                print("msgid \"%sheading%d\"" % (poPrefix, i), file=poFile)
                 generateMsgStr(poFile, heading[j])
 
@@ -810,5 +810,5 @@
                 for i in range(0, numLanguages):
                     poFile = poFiles[i]
-                    print >> poFile, "msgid \"%srow%d\"" % (poPrefix, rowIndex)
+                    print("msgid \"%srow%d\"" % (poPrefix, rowIndex), file=poFile)
                     generateMsgStr(poFile, columns[i])
             elif type==DELAYCODE:
@@ -819,20 +819,20 @@
                             if column[i]:
                                 poFile = poFiles[i]
-                                print >> poFile, "msgid \"%srow%d_col%d\"" % \
-                                  (poPrefix, rowIndex, columnIndex)
+                                print("msgid \"%srow%d_col%d\"" % \
+                                  (poPrefix, rowIndex, columnIndex), file=poFile)
                                 generateMsgStr(poFile, column[i])
                     columnIndex += 1
             rowIndex += 1
 
-        print >> dcdata, "import mlx.const as const"
-        print >> dcdata, "from mlx.i18n import xstr"
-        print >> dcdata
-        print >> dcdata, "CAPTION = 1"
-        print >> dcdata, "DELAYCODE = 2"
-        print >> dcdata
+        print("import mlx.const as const", file=dcdata)
+        print("from mlx.i18n import xstr", file=dcdata)
+        print(file=dcdata)
+        print("CAPTION = 1", file=dcdata)
+        print("DELAYCODE = 2", file=dcdata)
+        print(file=dcdata)
 
         tableMask = 1
         for i in range(0, len(tablePrefixes)):
-            print >> dcdata, "_%s_code2meaning = {" % (tablePrefixes[i],)
+            print("_%s_code2meaning = {" % (tablePrefixes[i],), file=dcdata)
 
             columnIndexes = []
@@ -850,25 +850,25 @@
 
                 if type==DELAYCODE:
-                    print >> dcdata, "    \"%s\": \"%s\"," % \
-                      (str(columns[codeIndex]).strip(), columns[meaningIndex][0].replace("\n", ""))
-
-            print >> dcdata, "}"
-            print >> dcdata
+                    print("    \"%s\": \"%s\"," % \
+                      (str(columns[codeIndex]).strip(), columns[meaningIndex][0].replace("\n", "")), file=dcdata)
+
+            print("}", file=dcdata)
+            print(file=dcdata)
 
             tableMask <<= 1
 
-        print >> dcdata, "def _extract(table, row):"
-        print >> dcdata, "    code = row[0].strip()"
-        print >> dcdata, "    meaning = table[code] if code in table else None"
-        print >> dcdata, "    return code + ((\" (\" + meaning + \")\") if meaning else \"\")"
-        print >> dcdata
+        print("def _extract(table, row):", file=dcdata)
+        print("    code = row[0].strip()", file=dcdata)
+        print("    meaning = table[code] if code in table else None", file=dcdata)
+        print("    return code + ((\" (\" + meaning + \")\") if meaning else \"\")", file=dcdata)
+        print(file=dcdata)
 
         tableMask = 1
         for i in range(0, len(tablePrefixes)):
 
-            print >> dcdata, "_%s_data = (" % (tablePrefixes[i],)
-            print >> dcdata, "    lambda row: _extract(_%s_code2meaning, row)," % \
-              (tablePrefixes[i],)
-            print >> dcdata, "    [",
+            print("_%s_data = (" % (tablePrefixes[i],), file=dcdata)
+            print("    lambda row: _extract(_%s_code2meaning, row)," % \
+              (tablePrefixes[i],), file=dcdata)
+            print("    [", end=' ', file=dcdata)
 
             columnIndexes = []
@@ -876,11 +876,11 @@
                 if ( (headingFlags[j]&tableMask)==tableMask ):
                     if columnIndexes:
-                        print >> dcdata, ",",
-                    print >> dcdata, "xstr(\"%sheading%d\")" % (poPrefix, j),
+                        print(",", end=' ', file=dcdata)
+                    print("xstr(\"%sheading%d\")" % (poPrefix, j), end=' ', file=dcdata)
                     columnIndexes.append(j)
 
-            print >> dcdata, "],"
-
-            print >> dcdata, "    ["
+            print("],", file=dcdata)
+
+            print("    [", file=dcdata)
 
             rowIndex = 0
@@ -891,43 +891,43 @@
 
                 if type==CAPTION:
-                    print >> dcdata, "        (CAPTION, xstr(\"%srow%d\"))," % \
-                      (poPrefix, rowIndex)
+                    print("        (CAPTION, xstr(\"%srow%d\"))," % \
+                      (poPrefix, rowIndex), file=dcdata)
                 elif type==DELAYCODE:
-                    print >> dcdata, "        (DELAYCODE, ["
+                    print("        (DELAYCODE, [", file=dcdata)
                     for j in columnIndexes:
                         column = columns[j]
                         if j!=columnIndexes[0]:
-                            print >> dcdata, ","
+                            print(",", file=dcdata)
                         if isinstance(column, list):
                             if column[0]:
-                                print >> dcdata, "            xstr(\"%srow%d_col%d\")"  % \
-                                (poPrefix, rowIndex, j),
+                                print("            xstr(\"%srow%d_col%d\")"  % \
+                                (poPrefix, rowIndex, j), end=' ', file=dcdata)
                             else:
-                                print >> dcdata, "            \"\"",
+                                print("            \"\"", end=' ', file=dcdata)
                         else:
-                            print >> dcdata, "            \"%s\""  % \
-                              (column,),
-                    print >> dcdata, "] ),"
+                            print("            \"%s\""  % \
+                              (column,), end=' ', file=dcdata)
+                    print("] ),", file=dcdata)
                 rowIndex += 1
 
-            print >> dcdata, "    ]"
-
-            print >> dcdata, ")"
-            print >> dcdata
+            print("    ]", file=dcdata)
+
+            print(")", file=dcdata)
+            print(file=dcdata)
 
             tableMask <<= 1
 
-        print >> dcdata, "def getTable(aircraftType):"
+        print("def getTable(aircraftType):", file=dcdata)
         first = True
         for i in range(0, len(tablePrefixes)):
             tablePrefix = tablePrefixes[i]
             for typeSuffix in typeGroups[i]:
-                print >> dcdata, "    %s aircraftType==const.AIRCRAFT_%s:" % \
-                  ("if" if first else "elif", typeSuffix)
-                print >> dcdata, "        return _%s_data" % (tablePrefix,)
+                print("    %s aircraftType==const.AIRCRAFT_%s:" % \
+                  ("if" if first else "elif", typeSuffix), file=dcdata)
+                print("        return _%s_data" % (tablePrefix,), file=dcdata)
                 first = False
 
-        print >> dcdata, "    else:"
-        print >> dcdata, "        return None"
+        print("    else:", file=dcdata)
+        print("        return None", file=dcdata)
     finally:
         for poFile in poFiles:
Index: diffdist.py
===================================================================
--- diffdist.py	(revision 310)
+++ diffdist.py	(revision 919)
@@ -18,5 +18,5 @@
 def usage():
     """Print a usage message."""
-    print "Usage: %s <old dist dir> <new dist dir>" % (sys.argv[0],)
+    print("Usage: %s <old dist dir> <new dist dir>" % (sys.argv[0],))
 
 #--------------------------------------------------------------------------
@@ -62,11 +62,11 @@
 
                 if numDiffs<=4:
-                    print "File %s is considered to be the same in both versions with %d changes" % \
-                          (path, numDiffs)
+                    print("File %s is considered to be the same in both versions with %d changes" % \
+                          (path, numDiffs))
                     finalManifest.addFile(path, oldSize, oldSum)
                     copyOld = True
 
         if not copyOld:
-            print ">>> File %s is being copied" % (path,)
+            print(">>> File %s is being copied" % (path,))
             tarFile.add(os.path.join(newDirectory, path), arcname = path)
             
@@ -74,5 +74,5 @@
     with os.fdopen(fd, "wt") as f:
         finalManifest.writeInto(f)
-    os.chmod(path, 0644)
+    os.chmod(path, 0o644)
     tarFile.add(path, arcname = manifestName)
     tarFile.close()
@@ -80,10 +80,10 @@
     os.remove(path)
 
-    print
-    print "%s created" % (tarName,)
+    print()
+    print("%s created" % (tarName,))
     if removed:
-        print
-        print "Files to remove:"
-        print
+        print()
+        print("Files to remove:")
+        print()
         for path in removed:
-            print "  ", path
+            print("  ", path)
Index: docker/build-mlxwinebuild.sh
===================================================================
--- docker/build-mlxwinebuild.sh	(revision 916)
+++ docker/build-mlxwinebuild.sh	(revision 939)
@@ -6,4 +6,4 @@
 sdistdir=$(cd $(dirname "${sdistfile}") && pwd)
 
-docker run --rm -v "${sdistdir}:/root/dist" mlxwinebuild build $(basename "${sdistfile}") $(id -u) $(id -g)
-#docker run -it --rm -v "${sdistdir}:/root/dist" mlxwinebuild bash
+docker run --rm -v "${sdistdir}:/root/dist" mlxwinebuild-py3 build $(basename "${sdistfile}") $(id -u) $(id -g)
+#docker run -it --rm -v "${sdistdir}:/root/dist" mlxwinebuild-py3 bash
Index: docker/context/Dockerfile
===================================================================
--- docker/context/Dockerfile	(revision 916)
+++ docker/context/Dockerfile	(revision 939)
@@ -8,4 +8,5 @@
         wine \
         wine32 && \
+    apt-get clean && \
     echo "Europe/Budapest" > /etc/timezone && \
     rm -f /etc/localtime && \
Index: docker/context/build.sh
===================================================================
--- docker/context/build.sh	(revision 916)
+++ docker/context/build.sh	(revision 939)
@@ -18,5 +18,6 @@
 cd "${mlxdirname}"
 
-echo "winemakeinst.bat" | wine cmd
+export WINE=yes
+./makeinst.sh
 
 echo
Index: docker/context/setup.sh
===================================================================
--- docker/context/setup.sh	(revision 916)
+++ docker/context/setup.sh	(revision 939)
@@ -4,9 +4,7 @@
 
 cdrive="${HOME}/.wine/drive_c"
-ctmpdir="${cdrive}/tmp"
-cpythondir="${cdrive}/Python27"
-cwinsysdir="${cdrive}/windows/system32"
+cpythondir="${cdrive}/msys64/mingw32"
 
-if test -f "${cpythondir}/python.exe"; then
+if test -f "${cpythondir}/bin/python3.exe"; then
     echo "Image already configured, not doing anything!"
     exit 1
@@ -16,37 +14,23 @@
 echo
 
+export WINEARCH=win32
+
+echo "exit" | wine cmd
+
 echo "Downloading and extracting the extra packages..."
 
-wget -O - mlx.varadiistvan.hu/update/winepkgs.tar | tar xf -
+wget -O - mlx.varadiistvan.hu/update/msys64.tar.gz | tar xzf - -C "${cdrive}"
+wget -O - mlx.varadiistvan.hu/update/winepkgs.tar | tar xf - nsis-2.46-setup.exe pyuipc-cpython-37m.dll xplra.py
+
+mv  pyuipc-cpython-37m.dll xplra.py /root/.wine/drive_c/msys64/mingw32/lib/python3.7/site-packages
 
 echo
 echo "Installing extra packages..."
 
-export WINEARCH=win32
-
-echo "exit" | wine cmd
-wine msiexec /i python-2.7.2.msi
-wine msiexec /i cefpython3-31.2.py2.7-win32.msi
-wine msiexec /i pygtk-all-in-one-2.24.1.win32-py2.7.msi
-wine msiexec /i pyuipc-0.4.win32-py2.7.msi
-wine msiexec /i xplra-0.2.win32.msi
-
-wine pywin32-217.win32-py2.7.exe
-wine py2exe-0.6.9.win32-py2.7.exe
 wine nsis-2.46-setup.exe
-
-mkdir "${ctmpdir}"
-cp chromedriver.exe "${ctmpdir}"
-
-tar xzf Python27.extra.tar.gz -C "${cpythondir}"
-
-touch -d "2015-02-22 14:50:07" "${cpythondir}/Lib/site-packages/win32/lib/win32con.py"
-touch -d "2015-02-22 14:50:07" "${cpythondir}/Lib/site-packages/win32/lib/winerror.py"
-
-cp python27.dll WINHTTP.dll "${cwinsysdir}"
 
 echo
 echo "Removing extra packages..."
-rm -f *.msi *.exe Python27.extra.tar.gz python27.dll WINHTTP.dll
+rm -f *.exe
 echo
 echo "Done."
Index: docker/initialize-mlxwinebuild.sh
===================================================================
--- docker/initialize-mlxwinebuild.sh	(revision 916)
+++ docker/initialize-mlxwinebuild.sh	(revision 939)
@@ -6,5 +6,5 @@
 scriptdir=`cd "${scriptdir}" && pwd`
 
-docker build -t mlxwinebuild-base "${scriptdir}/context"
+docker build -t mlxwinebuild-py3-base "${scriptdir}/context"
 
 if test -z "${XAUTHORITY:-}"; then
@@ -12,9 +12,9 @@
 fi
 
-docker run -it --name mlxwinebuildinit -v /tmp/.X11-unix:/tmp/.X11-unix -v "${XAUTHORITY}":/root/.Xauthority -v /usr/lib/x86_64-linux-gnu/vdpau:/usr/lib/x86_64-linux-gnu/vdpau --device /dev/nvidiactl --device /dev/nvidia0 --security-opt=apparmor:unconfined  --env DISPLAY mlxwinebuild-base initialize
+docker run -it --name mlxwinebuildinit -v /tmp/.X11-unix:/tmp/.X11-unix -v "${XAUTHORITY}":/root/.Xauthority -v /usr/lib/x86_64-linux-gnu/vdpau:/usr/lib/x86_64-linux-gnu/vdpau --device /dev/nvidiactl --device /dev/nvidia0 --security-opt=apparmor:unconfined  --env DISPLAY mlxwinebuild-py3-base initialize
 
 echo "Committing new image..."
 
-docker commit --change='CMD ["bash"]' mlxwinebuildinit mlxwinebuild
+docker commit --change='CMD ["bash"]' mlxwinebuildinit mlxwinebuild-py3
 
 echo "Removing container..."
Index: docker/msys/Dockerfile
===================================================================
--- docker/msys/Dockerfile	(revision 920)
+++ docker/msys/Dockerfile	(revision 920)
@@ -0,0 +1,25 @@
+#escape=`
+FROM mcr.microsoft.com/windows/servercore:1809
+SHELL ["powershell", "-Command"]
+
+RUN $WebClient = New-Object System.Net.WebClient ; `
+    $WebClient.DownloadFile('https://www.7-zip.org/a/7z1900-x64.msi', '7z.msi') ; `
+    $WebClient.DownloadFile('http://repo.msys2.org/distrib/msys2-x86_64-latest.tar.xz', 'msys2.tar.xz') ; `
+    Start-Process msiexec.exe -ArgumentList '/i C:\7z.msi /qn reboot=r' -Wait -PassThru -Verbose ; `
+    Start-Process 'C:\Program Files\7-Zip\7z.exe' -ArgumentList 'x msys2.tar.xz' -Wait -PassThru -Verbose ; `
+    Start-Process tar -ArgumentList 'xf msys2.tar' -Wait -PassThru -Verbose ; `
+    Start-Process msiexec.exe -ArgumentList '/x C:\7z.msi /qn reboot=r' -Wait -PassThru -Verbose ; `
+    Remove-Item msys2.tar ; `
+    Remove-Item msys2.tar.xz ; `
+    Remove-Item 7z.msi
+
+RUN $env:MSYSTEM='MINGW32' ; `
+    Start-Process C:\msys64\usr\bin\pacman.exe -ArgumentList '-Syu --noconfirm' -Wait -PassThru -Verbose -WorkingDirectory 'C:\msys64' ; `
+    Start-Process C:\msys64\usr\bin\pacman.exe -ArgumentList '-Su --noconfirm' -Wait -PassThru -Verbose -WorkingDirectory 'C:\msys64' ; `
+    Start-Process C:\msys64\usr\bin\bash.exe -ArgumentList '--login -c /usr/bin/true.exe' -Wait -PassThru -Verbose -WorkingDirectory 'C:\msys64'; `
+    mkdir C:\msys64\build
+
+COPY setup.sh pywin32.patch pywin32git.patch cef_binary_3.3359.1774.gd49d25f_windows32.patch cefpython-66.0.patch py2exe.patch C:\msys64\build\
+
+RUN $env:MSYSTEM='MINGW32'; `
+    C:\msys64\usr\bin\bash.exe --login  C:\msys64\build\setup.sh ;
Index: docker/msys/setup.sh
===================================================================
--- docker/msys/setup.sh	(revision 920)
+++ docker/msys/setup.sh	(revision 920)
@@ -0,0 +1,69 @@
+#!/bin/bash
+
+set -e -u
+
+pacman -S --noconfirm mc patch unzip mingw-w64-i686-python3 mingw-w64-i686-python3-setuptools mingw-w64-i686-gcc  mingw-w64-i686-gtk3 mingw-w64-i686-python3-lxml mingw-w64-i686-cmake mingw-w64-i686-make mingw-w64-i686-python3-pip mingw-w64-i686-python3-pillow mingw-w64-i686-python3-gobject mingw-w64-i686-python3-cffi
+pacman -Scc --noconfirm
+
+pip3 install jsonrpclib-pelix
+
+echo "Building PyWin32"
+
+cd /build
+
+wget -O - https://github.com/mhammond/pywin32/archive/b224.tar.gz | gzip -dc | tar xf -
+cd pywin32-b224
+patch -p1 < ../pywin32git.patch
+patch -p1 < ../pywin32.patch
+python3 setup.py build
+python3 setup.py install
+
+echo "Building CEFPython"
+
+cd /build
+
+wget -O - http://opensource.spotify.com/cefbuilds/cef_binary_3.3359.1774.gd49d25f_windows32.tar.bz2 | bzip2 -dc | tar xf -
+cd cef_binary_3.3359.1774.gd49d25f_windows32
+
+patch -p1 < ../cef_binary_3.3359.1774.gd49d25f_windows32.patch
+mv tests tests.orig
+
+mkdir build
+cd build
+/usr/bin/env PATH=/mingw32/bin:/usr/local/bin::/c/Windows/System32:/c/Windows:/c/Windows/System32/Wbem:/c/Windows/System32/WindowsPowerShell/v1.0 cmake  -G "MinGW Makefiles" ..
+cd libcef_dll_wrapper
+mingw32-make
+
+cd /build
+
+wget -O - https://github.com/cztomczak/cefpython/archive/v66.0.tar.gz | gzip -dc | tar xf -
+cd cefpython-66.0
+
+patch -p1 < ../cefpython-66.0.patch
+
+mkdir -p build
+cd build
+
+wget https://github.com/cztomczak/cefpython/releases/download/v66-upstream/cef66_3.3359.1774.gd49d25f_win32.zip
+unzip cef66_3.3359.1774.gd49d25f_win32.zip
+rm cef66_3.3359.1774.gd49d25f_win32.zip
+
+cp /build/cef_binary_3.3359.1774.gd49d25f_windows32/build/libcef_dll_wrapper/libcef_dll_wrapper.a cef66_3.3359.1774.gd49d25f_win32/lib
+
+pip3 install -r ../tools/requirements.txt
+
+python3 ../tools/build.py --no-run-tests --no-run-examples 66.0  || true
+python3 ../tools/build.py --no-run-tests --no-run-examples 66.0
+
+echo "Building Py2EXE"
+
+cd /build
+
+wget -O - https://github.com/albertosottile/py2exe/archive/v0.9.3.0.tar.gz | gzip -dc | tar xf -
+cd py2exe-0.9.3.0
+patch -p1 < ../py2exe.patch
+python3 setup.py build
+python3 setup.py install
+
+cd /
+rm -rf /build
Index: makeinst.sh
===================================================================
--- makeinst.sh	(revision 937)
+++ makeinst.sh	(revision 937)
@@ -0,0 +1,31 @@
+#!/bin/bash
+
+#set MSVCRDIR=c:\windows\winsxs\x86_Microsoft.VC90.CRT*9.0.21022.8*
+if test "${WINE}" = "yes"; then
+    cdrive="/root/.wine/drive_c/"
+    MINGW32DIR="c:/msys64/mingw32"
+
+    export GTKRTDIR="${MINGW32DIR}"
+    export CEFDIR="${MINGW32DIR}/lib/python3.7/site-packages/cefpython3"
+
+    export PYTHONHASHSEED=1234
+    export PYTHONIOENCODING=utf8
+    export PYTHONUTF8=1
+
+    wine "${cdrive}/msys64/mingw32/bin/python3.exe" setup.py py2exe
+
+    wine "${cdrive}/Program Files/NSIS/makensis.exe" mlx.nsi
+else
+    export GTKRTDIR=/mingw32
+    export CEFDIR=/mingw32/lib/python3.7/site-packages/cefpython3
+#set CHROMEDRIVER=c:\tmp\chromedriver.exe
+    export NSISDIR=/c/Program Files/NSIS
+
+    python3 setup.py py2exe
+    "$NSISDIR/makensis.exe" mlx.nsi
+fi
+
+#del dist\library\selenium\webdriver\chrome\service.pyc
+#copy patches\library\selenium\webdriver\chrome\service.py dist\library\selenium\webdriver\chrome\service.py
+#python -m compileall dist\library\selenium\webdriver\chrome\service.py
+#del dist\library\selenium\webdriver\chrome\service.py
Index: makesdist.sh
===================================================================
--- makesdist.sh	(revision 281)
+++ makesdist.sh	(revision 940)
@@ -2,3 +2,3 @@
 
 make
-python setup.py sdist
+python3 setup.py sdist
Index: runmlx.sh
===================================================================
--- runmlx.sh	(revision 577)
+++ runmlx.sh	(revision 933)
@@ -8,3 +8,6 @@
 https_proxy=
 
-exec python -m runmlx "$@"
+FORCE_PYGOBJECT=true
+export FORCE_PYGOBJECT
+
+exec python3 -m runmlx "$@"
